#ifndef _boardtypesh
#define _boardtypesh
/*

                          Argonne National Laboratory
                            APS Operations Division
                     Beamline Controls and Data Acquisition

                        Supported Board Types & IO Map


 -----------------------------------------------------------------------------
                                COPYRIGHT NOTICE
 -----------------------------------------------------------------------------
   Copyright (c) 2002 The University of Chicago, as Operator of Argonne
      National Laboratory.
   Copyright (c) 2002 The Regents of the University of California, as
      Operator of Los Alamos National Laboratory.
   Synapps Versions 4-5
   and higher are distributed subject to a Software License Agreement found
   in file LICENSE that is included with this distribution.
 -----------------------------------------------------------------------------

 Description
    This files defines the supported board types andthe IO map.

 Developer notes:

 Source control info:
    Modified by:    $Author: dkline $
                    $Date: 2006/08/22 12:57:03 $
                    $Revision: 1.8 $

 =============================================================================
 History:
 Author: David M. Kline
 -----------------------------------------------------------------------------
 2006-Mar-09  DMK  Development started.
 2006-May-19  DMK  Removed hardcoded address, lengths, and board type.
 2006-Jul-31  DMK  Added support for IR-104 modules.
 -----------------------------------------------------------------------------

*/


/******************************************************************************
 * Define symbolic constants for board types and hardcoded addresses
 ******************************************************************************/

/* Diamond Systems Corporation */
#define DSC_ATHENA      (1)
#define DSC_RMM416      (2)
#define DSC_PMM         (3)
#define DSC_OMM         (4)
#define DSC_GMM_PIO     (5)
#define DSC_GMM_FIX     (6)
#define DSC_GMM_AUX     (7)
#define DSC_IR4         (8)

/* Sensoray */
#define SEN_SDA518      (100)

/* Weeder Techologies */
#define WED_DIO         (200)
#define WED_TCI         (201)
#define WED_SSR         (202)
#define WED_SMD         (203)

/* Scalers */
#define SCL_GDIO        (300)
#define SCL_GMM         (301)

/* GPIB instruments */
#define GPIB_1ST        (400)


/* Hardcoded port addresses */
#define ATH_DAQ_BASE    (0x280)
#define ATH_WDT_BASE    (0x25C)

#endif /* _boardtypesh */
