#ifndef _drvscalerh
#define _drvscalerh
/*

                          Argonne National Laboratory
                            APS Operations Division
                     Beamline Controls and Data Acquisition

                         EPICS Brick Scaler Port Driver



 -----------------------------------------------------------------------------
                                COPYRIGHT NOTICE
 -----------------------------------------------------------------------------
   Copyright (c) 2002 The University of Chicago, as Operator of Argonne
      National Laboratory.
   Copyright (c) 2002 The Regents of the University of California, as
      Operator of Los Alamos National Laboratory.
   Synapps Versions 4-5
   and higher are distributed subject to a Software License Agreement found
   in file LICENSE that is included with this distribution.
 -----------------------------------------------------------------------------

 Description
    This module provides support for the Scaler port driver.

 Developer notes:

 Source control info:
    Modified by:    $Author: dkline $
                    $Date: 2006/07/24 19:02:29 $
                    $Revision: 1.1 $

 =============================================================================
 History:
 Author: David M. Kline
 -----------------------------------------------------------------------------
 2006-Jul-11  DMK  Development started.
 -----------------------------------------------------------------------------

*/


/* Define commands for the GDIO scaler */
#define CMD_ENA    (0x00)   	// Enable counter
#define CMD_DIS    (0x01)   	// Disable counter
#define CMD_PST    (0x02)   	// Preset counter
#define CMD_RES    (0x03)   	// Reset counter
#define CMD_UP     (0x04)   	// Set as up counter
#define CMD_DWN    (0x05)   	// Set as dwn counter 
#define CMD_IEA    (0x06)   	// Interrupt on done enable
#define CMD_IDS    (0x07)   	// Interrupt on done disable
#define CMD_GEA    (0x08)   	// Group enable
#define CMD_GDS    (0x09)   	// Group disable
#define CMD_LO     (0x0A)   	// Read data low
#define CMD_HI     (0x0B)   	// Read data high
#define CMD_TST    (0x0C)   	// Test
#define CMD_FWV    (0x0D)   	// Read firmware version
#define CMD_LOS    (0x0E)   	// Read status low
#define CMD_HIS    (0x0F)   	// Read status high
#define CMD_ICL    (0x10)   	// Interrupt on done clear
#define CMD_HZE    (0x11)   	// High Z enable
#define CMD_HZD    (0x12)   	// High Z disable
#define CMD_RAC    (0x13)   	// Reset all counters
#define CMD_ACU    (0x14)   	// All counters up
#define CMD_ACD    (0x15)   	// All counters down

#define STS_ENA    (1)      	// Enable counter
#define STS_DIS    (2)      	// Disable counter
#define STS_UP     (16)     	// Set as up counter
#define STS_DWN    (32)     	// Set as dwn counter 
#define STS_IEA    (64)     	// Interrupt on done enable
#define STS_IDS    (128)    	// Interrupt on done disable
#define STS_GEA    (256)    	// Group enable
#define STS_GDS    (512)    	// Group disable
#define STS_HZE    (131072)   	// High Z enable
#define STS_HZD    (262144)   	// High Z disable

#endif /* _drvscalerh */
