# Athena initialization
# drvAthenaInit(rstbrd,rstda,rstfifo,clrdma,clrt,clrd,clra)
#     rst* - Reset component
#     clr* - Clear interrupt
drvAthenaInit(1,1,1,0,0,0,0)

# Digital I/O
# drvDioInit(port,type,inst,addr,regs)
#     port - Asyn port name (string)
#     type - Board type (see docs/BOARDTYPES)
#     inst - Board instance
#     addr - Board address, zero for Athena
#     regs - Register count

# Athena
drvDioInit("ATHDIO",1,0,0,3)
dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=ath01:,F=reg01:,D=inpb,R=0,PORT=ATHDIO")
dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=ath01:,F=reg02:,D=inpb,R=1,PORT=ATHDIO")
dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=ath01:,F=reg03:,D=outb,R=2,PORT=ATHDIO")
dbLoadTemplate("ebrickATHDIG.substitutions")

# RMM416 Instance 0
#drvDioInit("RMMDIO1",2,0,0x2C0,3)
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=rmm01:,F=reg01:,D=outb,R=0,PORT=RMMDIO1")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=rmm01:,F=reg02:,D=inpb,R=1,PORT=RMMDIO1")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=rmm01:,F=reg03:,D=outb,R=2,PORT=RMMDIO1")
#dbLoadTemplate("ebrickRMM1DIG.substitutions")

# RMM416 Instance 1
#drvDioInit("RMMDIO2",2,0,0x300,3)
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=rmm02:,F=reg01:,D=outb,R=0,PORT=RMMDIO2")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=rmm02:,F=reg02:,D=inpb,R=1,PORT=RMMDIO2")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=rmm02:,F=reg03:,D=outb,R=2,PORT=RMMDIO2")
#dbLoadTemplate("ebrickRMM2DIG.substitutions")

# PMM Instance 0
#drvDioInit("PMMDIO1",3,0,0x340,2)
#dbLoadTemplate("ebrickPMM1.substitutions")

# PMM Instance 1
#drvDioInit("PMMDIO2",3,1,0x380,2)
#dbLoadTemplate("ebrickPMM2.substitutions")

# OMM Instance 0
#drvDioInit("OMMDIO1",4,0,0x300,6)
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=omm01:,F=reg01:,D=inpb,R=0,PORT=OMMDIO1")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=omm01:,F=reg02:,D=inpb,R=1,PORT=OMMDIO1")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=omm01:,F=reg03:,D=outb,R=2,PORT=OMMDIO1")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=omm01:,F=reg04:,D=inpb,R=3,PORT=OMMDIO1")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=omm01:,F=reg05:,D=inpb,R=4,PORT=OMMDIO1")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=omm01:,F=reg06:,D=outb,R=5,PORT=OMMDIO1")
#dbLoadTemplate("ebrickOMM1DIG.substitutions")

# OMM Instance 1
#drvDioInit("OMMDIO2",4,1,0x350,6)
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=omm02:,F=reg01:,D=inpb,R=0,PORT=OMMDIO2")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=omm02:,F=reg02:,D=inpb,R=1,PORT=OMMDIO2")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=omm02:,F=reg03:,D=outb,R=2,PORT=OMMDIO2")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=omm02:,F=reg04:,D=inpb,R=3,PORT=OMMDIO2")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=omm02:,F=reg05:,D=inpb,R=4,PORT=OMMDIO2")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=omm02:,F=reg06:,D=outb,R=5,PORT=OMMDIO2")
#dbLoadTemplate("ebrickOMM2DIG.substitutions")

# GMM Instance 0
#drvDioInit("GMMPIO1",5,0,0x340,6)
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=gmm01:,F=pio01:,D=inpb,R=0,PORT=GMMPIO1")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=gmm01:,F=pio02:,D=inpb,R=1,PORT=GMMPIO1")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=gmm01:,F=pio03:,D=outb,R=2,PORT=GMMPIO1")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=gmm01:,F=pio04:,D=inpb,R=3,PORT=GMMPIO1")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=gmm01:,F=pio05:,D=inpb,R=4,PORT=GMMPIO1")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=gmm01:,F=pio06:,D=outb,R=5,PORT=GMMPIO1")
#dbLoadTemplate("ebrickGMM1PIO.substitutions")

#drvDioInit("GMMFIX1",6,0,0x380,2)
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=gmm01:,F=fix01:,D=inpb,R=0,PORT=GMMFIX1")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=gmm01:,F=fix02:,D=outb,R=1,PORT=GMMFIX1")
#dbLoadTemplate("ebrickGMM1FIX.substitutions")

# GMM Instance 1
#drvDioInit("GMMPIO2",5,1,0x300,6)
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=gmm02:,F=reg01:,D=inpb,R=0,PORT=GMMPIO2")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=gmm02:,F=reg02:,D=inpb,R=1,PORT=GMMPIO2")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=gmm02:,F=reg03:,D=outb,R=2,PORT=GMMPIO2")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=gmm02:,F=reg04:,D=inpb,R=3,PORT=GMMPIO2")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=gmm02:,F=reg05:,D=inpb,R=4,PORT=GMMPIO2")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=gmm02:,F=reg06:,D=outb,R=5,PORT=GMMPIO2")
#dbLoadTemplate("ebrickGMM2PIO.substitutions")

#drvDioInit("GMMFIX2",6,1,0x340,2)
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=gmm02:,F=fix01:,D=inpb,R=0,PORT=GMMFIX2")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=gmm02:,F=fix02:,D=outb,R=1,PORT=GMMFIX2")
#dbLoadTemplate("ebrickGMM2FIX.substitutions")

# IR4 Instance 0
#drvDioInit("IR4DIO1",8,0,0x300,6)
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=ir401:,F=reg01:,D=outb,R=0,PORT=IR4DIO1")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=ir401:,F=reg02:,D=outb,R=1,PORT=IR4DIO1")
#dbLoadRecords("../../db/ebrickDIOout.db","P=ebr:,H=ir401:,F=reg03:,D=outb,R=2,PORT=IR4DIO1")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=ir401:,F=reg04:,D=inpb,R=3,PORT=IR4DIO1")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=ir401:,F=reg05:,D=inpb,R=4,PORT=IR4DIO1")
#dbLoadRecords("../../db/ebrickDIOinp.db","P=ebr:,H=ir401:,F=reg06:,D=inpb,R=5,PORT=IR4DIO1")
#dbLoadTemplate("ebrickIR41DIG.substitutions")

# Analog input channels
# drvAdcInit(port,type,inst,addr,freq,conv,gain)
#     port - Asyn port name (string)
#     type - Board type (see docs/BOARDTYPES)
#     inst - Board instance
#     addr - Board address, zero for Athena
#     freq - Sample frequency Hz (1..100)
#     conv - Conversion (Bipolar=0,Unipolar=1)
#     gain - Input gain (1,2,4,8)

# Athena
drvAdcInit("ATHADC",1,0,0,25,0,1)
dbLoadTemplate("ebrickADC.substitutions")

# Analog output channels
# drvDacInit(port,type,inst,addr,chns)
#     port - Asyn port name (string)
#     type - Board type (see docs/BOARDTYPES)
#     inst - Board instance
#     addr - Board address, zero for Athena
#     chns - Channel count

# Athena
drvDacInit("ATHDAC",1,0,0,4)
dbLoadTemplate("ebrickDAC.substitutions")

# RMM416
#drvDacInit("RMMDAC1",2,0,0x2C0,4)
#dbLoadTemplate("ebrickRMM1DAC.substitutions")

#drvDacInit("RMMDAC2",2,1,0x300,4)
#dbLoadTemplate("ebrickRMM2DAC.substitutions")

# Watchdog support
# drvWdtInit(port)
#     port - Asyn port name (string)
drvWdtInit("ATHWDT")
dbLoadTemplate("ebrickWDT.substitutions")

# Scaler support
# drvScalerInit(myport,ioport,type,inst,addr,ctrs)
#     myport - Asyn port driver name
#     ioport - Digital IO port driver name (optional)
#     type   - Board type (see docs/BOARDTYPES)
#     inst   - Board instance
#     addr   - Board address, zero for GIO board
#     ctrs   - Counters

# Generic digital IO board Scaler
#drvScalerInit("GDIOSCAL","ATHDIO",300,0,0,33)
#dbLoadTemplate("ebrickSCAL.substitutions")

# devScalerInit(port,type,inst,scls,freq,rate)
#     port - Asyn port driver name
#     type - Board type (see docs/BOARDTYPES)
#     inst - Board instance
#     scls - Scalers
#     rate - Poll frequency (in Hz)
#devScalerInit("GDIOSCAL",300,0,16,4)
#dbLoadRecords("../../db/scaler.db","P=ebr:,S=scaler1,C=0,DTYP=devAsynScaler,FREQ=10")

# Sensoray's Smart A/D Model 518
# drvSenInit(port,type,inst,addr,chns,freq)
#     port - Asyn port name (string)
#     type - Board type (see docs/BOARDTYPES)
#     inst - Board instance
#     addr - Board address, zero for Athena
#     chns - Channel count
#     freq - Sample frequency (1Hz..5Hz)
# drvSenConfig(port,chn,type)
#     port - Asyn port name (string)
#     chn  - Channel number
#     type - Sensor type
#

# SAD Instance 0
#drvSenInit("SEN1",100,0,0x390,8,5)
#drvSenConfig("SEN1",0,11)
#drvSenConfig("SEN1",1,11)
#drvSenConfig("SEN1",2,11)
#drvSenConfig("SEN1",3,11)
#drvSenConfig("SEN1",4,11)
#drvSenConfig("SEN1",5,11)
#drvSenConfig("SEN1",6,11)
#drvSenConfig("SEN1",7,11)
#dbLoadTemplate("ebrickSEN1.substitutions")

# SAD Instance 1
#drvSenInit("SEN2",100,1,0x3A0,8,5)
#drvSenConfig("SEN2",0,11)
#drvSenConfig("SEN2",1,11)
#drvSenConfig("SEN2",2,11)
#drvSenConfig("SEN2",3,11)
#drvSenConfig("SEN2",4,11)
#drvSenConfig("SEN2",5,11)
#drvSenConfig("SEN2",6,11)
#drvSenConfig("SEN2",7,11)
#dbLoadTemplate("ebrickSEN2.substitutions")

# SAD Instance 2
#drvSenInit("SEN3",100,2,0x380,8,5)
#drvSenConfig("SEN3",0,11)
#drvSenConfig("SEN3",1,11)
#drvSenConfig("SEN3",2,11)
#drvSenConfig("SEN3",3,11)
#drvSenConfig("SEN3",4,11)
#drvSenConfig("SEN3",5,11)
#drvSenConfig("SEN3",6,11)
#drvSenConfig("SEN3",7,11)
#dbLoadTemplate("ebrickSEN3.substitutions")

# Weeder Techologies Support
# drvWeedInit(myport,serport,type,inst,chns,freq)
#     myport  - Port driver name (string)
#     serport - Serial port driver name (string)
#     seraddr - Serial port driver address
#drvWeedInit("WTT1","S1",-1)

# drvWeedConfig(port,addr,type,chns)
#     port - Port driver name (string)
#     addr - Controller address
#     type - Controller type
#     chns - Channel count
#
#drvWeedConfig("WTT1",0,200,14)
#drvWeedConfig("WTT1",1,201,4)
#drvWeedConfig("WTT1",2,202,5)

# Load database
#dbLoadTemplate("ebrickWTDIO1.substitutions")
#dbLoadTemplate("ebrickWTTCI1.substitutions")
#dbLoadTemplate("ebrickWTSSR1.substitutions")
